    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.data;
    034
    035/**
    036 * A generic representation of a two dimensional grid of data values.
    037 *
    038 * @param <T> the type of value stored in the grid.
    039 */
    040public interface Values2D<T> {
    041
    042    /**
    043     * Returns the number of rows in the grid.
    044     *
    045     * @return The number of rows in the grid.
    046     */
    047    int getRowCount();
    048
    049    /**
    050     * Returns the number of columns in the grid.
    051     *
    052     * @return The number of columns in the grid.
    053     */
    054    int getColumnCount();
    055
    056    /**
    057     * Returns the data item at the specified position.
    058     *
    059     * @param rowIndex  the row index.
    060     * @param columnIndex  the column index.
    061     *
    062     * @return The data value (possibly {@code null}).
    063     */
    064    T getValue(int rowIndex, int columnIndex);
    065
    066    /**
    067     * Returns the data value at the specified position as a double primitive,
    068     * or {@code Double.NaN} if the value is not an instance of
    069     * {@code Number}.  Where the {@link #getValue(int, int)} method
    070     * returns {@code null}, this method returns {@code Double.NaN}.
    071     *
    072     * @param rowIndex  the row index.
    073     * @param columnIndex  the column index.
    074     *
    075     * @return The data value.
    076     */
    077    double getDoubleValue(int rowIndex, int columnIndex);
    078
    079}